#define __USE_FILE_OFFSET64
#define __USE_LARGEFILE64


#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <time.h>



#define REC_SIZE    (100)
#define BUF_BYTES (REC_SIZE)

unsigned char Buf[BUF_BYTES];


int main( int argc, const char *argv[] ) {

    int i, j;
    FILE *out;
    const char* filename = "sortdata";
    int numrecs = 0;
    
    srand( time( NULL ) );
    
    if( argc <= 2 ) {
        printf( "usage: dmsortgen <numrecs> <file>\n" );
        return( 0 );
    }
    
    out = fopen( argv[2], "wb" );
    if( !out ) {
        printf( "couldn't open '%s'\n" );
        return( 0 );
    }
    
    numrecs = atoi( argv[1] );
    if( numrecs <= 0 ) {
        printf( "numrecs screwy: %d\n", numrecs );
        return( 0 );
    }
    
    for( i = 0; i < numrecs; i++ ) {
        for( j = 0; j < REC_SIZE; j++ ) {
            unsigned char c = rand();
            Buf[j] = c;
        }
	fwrite( Buf, 1, REC_SIZE, out );
    }
    
    fclose( out );
    
    return( 0 );
    
}

