#include <stdlib.h>
#include <stdio.h>


#include "buffer.h"


#define BUFRECS     (1311)
record_t buf[BUFRECS];

static int Error = 0;


/*
int CompareKeys( const record_t *r1, const record_t *r2 ) {

    return( memcmp( r1->key, r2->key, sizeof( r1->key ) ) );

}
*/



int main( int argc, const char *argv[] ) {

    FILE *in;
    int numrecs = 0;
    int i;
	int comp_result;
	
    int processed = 0;
    int inbuf = 0;


    if( argc < 3 ) {
        printf( "usage: dmverify <datafile> <numrecs>\n" );
        return( 0 );
    }

    in = fopen( argv[1], "rb" );
    if( in == NULL ) {
        printf( "couldn't open '%s' for read!\n", argv[1] );
        return( 0 );
    }

    numrecs = atoi( argv[2] );

    
    if( numrecs <= 0 ) {
        printf( "invalid numrecs: %d\n", numrecs );
        return( 0 );
    }
    

    while( processed < numrecs ) {

        // read chunk.
        inbuf = (numrecs-processed) > BUFRECS ? BUFRECS : (numrecs-processed);
        fread( buf, inbuf, sizeof( buf[0] ), in );

        // process buf.
        for( i = 0; i < (inbuf-1); i++ ) {
        	comp_result = COMPARE_KEYS( buf[i], buf[i+1] );
            if( comp_result > 0 ) {
                printf( "FAILED! DATA NOT IN ORDER!  RECORD # %d > RECORD # %d\n", 
                    processed + i, processed + i + 1 );

                printf( "Record %d: %.2x %.2x %.2x %.2x %.2x %.2x %.2x %.2x %.2x %.2x\n", processed + i,
                buf[i].key[0], buf[i].key[1], buf[i].key[2], buf[i].key[3], buf[i].key[4], 
                buf[i].key[6], buf[i].key[7], buf[i].key[8], buf[i].key[9], buf[i].key[10] ); 
				i++;
                printf( "Record %d: %.2x %.2x %.2x %.2x %.2x %.2x %.2x %.2x %.2x %.2x\n", processed + i,
                buf[i].key[0], buf[i].key[1], buf[i].key[2], buf[i].key[3], buf[i].key[4], 
                buf[i].key[6], buf[i].key[7], buf[i].key[8], buf[i].key[9], buf[i].key[10] ); 
                i--;
                Error = 1;
            }else if( comp_result == 0 ){
                printf( "Equal keys found.  RECORD # %d > RECORD # %d\n", 
                    processed + i, processed + i + 1 );
            }
        }

        processed += inbuf;

    }

    if( !Error ) {
        printf( "PASSED: All data has keys monotonically non-decreasing.\n" );
    }

    fclose( in );
    return( 0 );

}